﻿
var survey = function () {
    
    // Change Storage Version to empty the local storage
    var localStorageSchemaVersion = '20130201-2';
    var fileName = "survey-data.txt";
    var db = null;
    var sName = "sDatabase";
    var nVersion = 5;
    var table = "surveys";
    var IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction;

    var submitForm = function () {

        if (db) {

            var tx = db.transaction([table], "readwrite");
            var surveyOs = tx.objectStore(table);
        
            var ddlProvince = document.getElementById("ddlProvince");
            var rbOwnCopy = "";
            if (document.getElementById("rbCheckOwnCopyYes").checked) { rbOwnCopy = "Yes"; }
            if (document.getElementById("rbCheckOwnCopyNo").checked) { rbOwnCopy = "No"; }
            var ddlEducational = document.getElementById("ddlEducational");
            var ddlTimeSpent = document.getElementById("ddlTimeSpent");
            var ddlHelpfulness = document.getElementById("ddlHelpfulness");
            var rbContribution = "";
            if (document.getElementById("rbCheckContributionYes").checked) { rbContribution = "Yes"; }
            if (document.getElementById("rbCheckContributionNo").checked) { rbContribution = "No"; }
            var productList = [];
            var recommendedProducts = document.getElementsByName("RecommendedProduct");
            for (var i = 0; i < recommendedProducts.length; i++) {
                if (recommendedProducts[i].checked) {
                    productList.push(recommendedProducts[i].value);
                }
            }
            var magOfferList = [];
            var magOffers = document.getElementsByName("MagazineOffer");
            for (var i = 0; i < magOffers.length; i++) {
                if (magOffers[i].checked) {
                    magOfferList.push(magOffers[i].value);
                }
            }

            var formData = {
                CheckReceive: document.getElementById("cbCheckReceive").checked.toString(),
                CheckOnline: document.getElementById("cbCheckOnline").checked.toString(),
                CheckRenew: document.getElementById("cbCheckRenew").checked.toString(),
                Name: document.getElementById("txtName").value,
                Address: document.getElementById("txtAddress").value,
                City: document.getElementById("txtCity").value,
                Province: ddlProvince.options[ddlProvince.selectedIndex].value,
                PostalCode: document.getElementById("txtPostalCode").value,
                Phone: document.getElementById("txtPhone").value,
                Fax: document.getElementById("txtFax").value,
                Email: document.getElementById("txtEmail").value,
                CheckOwnCopy: rbOwnCopy,
                NumberOfReaders: document.getElementById("txtNumberOfReaders").value,
                Educational: ddlEducational.options[ddlEducational.selectedIndex].value,
                EducationalComment: document.getElementById("txtCheckEducationalComment").value,
                TimeSpent: ddlTimeSpent.options[ddlTimeSpent.selectedIndex].value,
                Helpfulness: ddlHelpfulness.options[ddlHelpfulness.selectedIndex].value,
                HelpfulnessComment: document.getElementById("txtHelpfulnessComment").value,
                PreferredInfo: document.getElementById("txtPreferredInfo").value,
                RecommendedProduct: productList.join(' , '),
                WebsiteVisits: document.getElementById("txtWebsiteVisits").value,
                SocialVisits: document.getElementById("txtSocialVisits").value,
                MagazineOffer: magOfferList.join(' , '),
                CheckContribution: rbContribution
            };
            var addReq = surveyOs.add(formData);
            addReq.onsuccess = function (evt) {
                //document.getElementById('test').innerHTML = "awesome";

                var messageDialog = new Windows.UI.Popups.MessageDialog("Thank you for completing the survey!");
                messageDialog.commands.append(new Windows.UI.Popups.UICommand("Close", clearForm));
                // Set the command that will be invoked by default
                messageDialog.defaultCommandIndex = 0;
                // Set the command to be invoked when escape is pressed
                messageDialog.cancelCommandIndex = 1;
                messageDialog.showAsync();
            };
            
            //tx.complete = function () {
            // All requests have successed and the transaction has committed
            //};
        }
    };

    var clearForm = function () {
        document.getElementById("cbCheckReceive").checked = false;
        document.getElementById("cbCheckOnline").checked = false;
        document.getElementById("cbCheckRenew").checked = false;
        
        document.getElementById("txtName").value = "";
        document.getElementById("txtAddress").value = "";
        document.getElementById("txtCity").value = "";
        ddlProvince.selectedIndex = 0;
        document.getElementById("txtPostalCode").value = "";
        document.getElementById("txtPhone").value = "";
        document.getElementById("txtFax").value = "";
        document.getElementById("txtEmail").value = "";
        
        document.getElementById("rbCheckOwnCopyYes").checked = false;
        document.getElementById("rbCheckOwnCopyNo").checked = false;
        
        document.getElementById("txtNumberOfReaders").value = "";
        ddlEducational.selectedIndex = 0;
        document.getElementById("txtCheckEducationalComment").value = "";
        ddlTimeSpent.selectedIndex = 0;
        ddlHelpfulness.selectedIndex = 0;
        document.getElementById("txtHelpfulnessComment").value = "";
        document.getElementById("txtPreferredInfo").value = "";
        var recommendedProducts = document.getElementsByName("RecommendedProduct");
        for (var i = 0; i < recommendedProducts.length; i++) {
            recommendedProducts[i].checked = false;
        }
        document.getElementById("txtWebsiteVisits").value = "";
        document.getElementById("txtSocialVisits").value = "";
        var magOffers = document.getElementsByName("MagazineOffer");
        for (var i = 0; i < magOffers.length; i++) {
            magOffers[i].checked = false;
        }
        document.getElementById("rbCheckContributionYes").checked = false;
        document.getElementById("rbCheckContributionNo").checked = false;

    }; // end of clearForm    

    var exportToFile = function () {

        Windows.Storage.KnownFolders.documentsLibrary.createFileAsync("surveys.csv", Windows.Storage.CreationCollisionOption.replaceExisting).then(function (file) {

            if (db) {
                var tx = db.transaction(table, "readwrite");
                var store = tx.objectStore(table);

                var tem = '';
                tem += 'SurveyId \t';
                tem += 'ToReceive \t';
                tem += 'Online \t';
                tem += 'Renew \t';
                tem += 'Name \t';
                tem += 'Address \t';
                tem += 'City \t';
                tem += 'Province \t';
                tem += 'PostalCode \t';
                tem += 'Phone \t';
                tem += 'Fax \t';
                tem += 'OwnCopy \t';
                tem += 'NumberOfReaders \t';
                tem += 'Educational \t';
                tem += 'EducationalComment \t';
                tem += 'TimeSpent \t';
                tem += 'Helpfulness \t';
                tem += 'HelpfulnessComment \t';
                tem += 'PreferredInfo \t';
                tem += 'RecommendedProduct \t';
                tem += 'WebsiteVisits \t';
                tem += 'SocialVisits \t';
                tem += 'MagazineOffer \t';
                tem += 'Conntribution \t';
                tem += '\r\n';

                var request = store.openCursor();
                request.onsuccess = function (evt) {

                    var cursor = evt.target.result;
                    if (cursor) {                        
                        tem += cursor.value.SurveyId + '\t';
                        tem += cursor.value.CheckReceive.toString() + '\t';
                        tem += cursor.value.CheckOnline.toString() + '\t';
                        tem += cursor.value.CheckRenew.toString() + '\t';
                        tem += cursor.value.Name + '\t';
                        tem += cursor.value.Address + '\t';
                        tem += cursor.value.City + '\t';
                        tem += cursor.value.Province + '\t';
                        tem += cursor.value.PostalCode + '\t';
                        tem += cursor.value.Phone + '\t';
                        tem += cursor.value.Fax + '\t';
                        tem += cursor.value.CheckOwnCopy + '\t';
                        tem += cursor.value.NumberOfReaders + '\t';
                        tem += cursor.value.Educational + '\t';
                        tem += cursor.value.EducationalComment + '\t';
                        tem += cursor.value.TimeSpent + '\t';
                        tem += cursor.value.Helpfulness + '\t';
                        tem += cursor.value.HelpfulnessComment + '\t';
                        tem += cursor.value.PreferredInfo + '\t';
                        tem += cursor.value.RecommendedProduct + '\t';
                        tem += cursor.value.WebsiteVisits + '\t';
                        tem += cursor.value.SocialVisits + '\t';
                        tem += cursor.value.MagazineOffer + '\t';
                        tem += cursor.value.CheckContribution + '\t';
                        tem += '\r\n';

                        cursor.continue();

                    } else {

                        Windows.Storage.FileIO.writeTextAsync(file, tem).then(function () {
                            //document.getElementById("sample").innerHTML = "file written";

                            var dialog = new Windows.UI.Popups.MessageDialog("Your data has been successfully exported to surveys.csv in Documents folder!");
                            dialog.commands.append(new Windows.UI.Popups.UICommand("Close", function () { }));
                            // Set the command that will be invoked by default
                            dialog.defaultCommandIndex = 0;
                            // Set the command to be invoked when escape is pressed
                            dialog.cancelCommandIndex = 1;
                            dialog.showAsync();
                      
                        });
                    }
                };
            }           
        });
    };

    var that = {
        // Check local storage schema version
        checkLocalStorageSchemaVersion: function () {
            if (localStorage === null || localStorage.schemaVersion === null || localStorage.schemaVersion !== this.localStorageSchemaVersion)
                survey.clearLocalStorage();
        },

        // Clear all local storage
        clearLocalStorage: function () {
            localStorage.clear();
            localStorage.schemaVersion = this.localStorageSchemaVersion;
        },

        exportSurveys: function() {
            exportToFile();
        },

        submitSurveyForm: function() {
            submitForm();
        },

        clearSurveyForm: function() {
            clearForm();
        },

        gotoViewAll: function() {
            WinJS.Navigation.navigate("/html/viewall.html");
        },

        gotoForm: function() {
            WinJS.Navigation.navigate("/html/form.html");
        },

        listAll: function() {
            //document.getElementById("sample").value
            if (db) {
                var tx = db.transaction(table, "readwrite");
                var store = tx.objectStore(table);

                //var dataList = [];
                var request = store.openCursor();
                request.onsuccess = function (evt) {
                    
                    var cursor = evt.target.result;
                    if (cursor) {
                        document.getElementById("sample").innerHTML = cursor.value.CheckReceive.toString();
                        var tem = '<div class="template-row">';
                        tem += '<div class="template-column-1">' + cursor.value.SurveyId + '</div>';
                        tem += '<div class="template-column-2">' + cursor.value.CheckReceive.toString() + '</div>';
                        tem += '<div class="template-column-3">' + cursor.value.CheckOnline.toString() + '</div>';
                        tem += '<div class="template-column-4">' + cursor.value.CheckRenew.toString() + '</div>';
                        tem += '<div class="template-column-5">' + cursor.value.Name + '</div>';
                        tem += '<div class="template-column-6">' + cursor.value.Address + '</div>';
                        tem += '<div class="template-column-7">' + cursor.value.City + '</div>';
                        tem += '<div class="template-column-8">' + cursor.value.Province + '</div>';
                        tem += '<div class="template-column-9">' + cursor.value.PostalCode + '</div>';
                        tem += '<div class="template-column-10">' + cursor.value.Phone + '</div>';
                        tem += '<div class="template-column-11">' + cursor.value.Fax + '</div>';
                        tem += '<div class="template-column-12">' + cursor.value.CheckOwnCopy + '</div>';
                        tem += '<div class="template-column-13">' + cursor.value.NumberOfReaders + '</div>';
                        tem += '<div class="template-column-14">' + cursor.value.Educational + '</div>';
                        tem += '<div class="template-column-15">' + cursor.value.EducationalComment + '</div>';
                        tem += '<div class="template-column-16">' + cursor.value.TimeSpent + '</div>';
                        tem += '<div class="template-column-17">' + cursor.value.Helpfulness + '</div>';
                        tem += '<div class="template-column-18">' + cursor.value.HelpfulnessComment + '</div>';
                        tem += '<div class="template-column-19">' + cursor.value.PreferredInfo + '</div>';
                        tem += '<div class="template-column-20">' + cursor.value.RecommendedProduct + '</div>';
                        tem += '<div class="template-column-21">' + cursor.value.WebsiteVisits + '</div>';
                        tem += '<div class="template-column-22">' + cursor.value.SocialVisits + '</div>';
                        tem += '<div class="template-column-23">' + cursor.value.MagazineOffer + '</div>';
                        tem += '<div class="template-column-24">' + cursor.value.CheckContribution + '</div>';
                        tem += '</div>';

                        document.getElementById("SurveyTable2").innerHTML += tem;

                        //var singleData = {
                        //    SurveyId: cursor.key,
                        //    CheckReceive: cursor.value.CheckReceive.toString(),
                        //    CheckOnline: cursor.value.CheckOnline.toString(),
                        //    CheckRenew: cursor.value.CheckRenew.toString(),
                        //    Name: cursor.value.Name,
                        //    Address: cursor.value.Address,
                        //    City: cursor.value.City,
                        //    Province: cursor.value.Province,
                        //    PostalCode: cursor.value.PostalCode,
                        //    Phone: cursor.value.Phone,
                        //    Fax: cursor.value.Fax,
                        //    Email: cursor.value.Email,
                        //    CheckOwnCopy: cursor.value.CheckOwnCopy.toString(),
                        //    NumberOfReaders: cursor.value.NumberOfReaders.toString(),
                        //    Educational: cursor.value.Educational.toString(),
                        //    EducationalComment: cursor.value.EducationalComment.toString(),
                        //    TimeSpent: cursor.value.TimeSpent.toString(),
                        //    Helpfulness: cursor.value.Helpfulness.toString(),
                        //    HelpfulnessComment: cursor.value.HelpfulnessComment.toString(),
                        //    PreferredInfo: cursor.value.PreferredInfo.toString(),
                        //    RecommendedProduct: cursor.value.RecommendedProduct.toString(),
                        //    WebsiteVisits: cursor.value.WebsiteVisits.toString(),
                        //    SocialVisits: cursor.value.SocialVisits.toString(),
                        //    MagazineOffer: cursor.value.MagazineOffer.toString(),
                        //    CheckContribution: cursor.value.CheckContribution.toString()
                        //};
                        //dataList.push(singleData);
                        
                        cursor.continue();
                    } else {
                        //var myDataSource = new WinJS.Binding.List(dataList);
                        //var listView = document.getElementById("SurveyTable").winControl;
                        //listView.itemDataSource = myDataSource.dataSource;
                    }
                };

                
                //document.getElementById("sample").innerHTML = upperBound.toString();
                //var request = store.openCursor(IDBKeyRange.bound(
            }
        },

        closeConnection: function() {
            if (db) { db.close(); }
        },

        initialize: function () {

            if (window.indexedDB) {
                var req = window.indexedDB.open(sName, nVersion);
                req.onsuccess = function (evt) {
                    db = req.result;
                };

                req.onupgradeneeded = function (evt) {
                    var db = req.result;
                    
                    //db.deleteObjectStore(table);
                    //document.getElementById('test').innerHTML = evt.newVersion;
                    //if (evt.oldVersion < 1) {
                    var survey = db.createObjectStore(table, { keyPath: "SurveyId", autoIncrement:true});
                    var checkReceiveIndex = survey.createIndex("by_checkreceive", "CheckReceive");
                    var checkOnlineIndex = survey.createIndex("by_checkonline", "CheckOnline");
                    var checkRenewIndex = survey.createIndex("by_checkrenew", "CheckRenew");

                    var nameIndex = survey.createIndex("by_name", "Name");
                    var addressIndex = survey.createIndex("by_address", "Address");
                    var cityIndex = survey.createIndex("by_city", "City");
                    var provinceIndex = survey.createIndex("by_province", "Province");
                    var postalCodeIndex = survey.createIndex("by_postalcode", "PostalCode");
                    var phoneIndex = survey.createIndex("by_phone", "Phone");
                    var faxIndex = survey.createIndex("by_fax", "Fax");
                    var emailIndex = survey.createIndex("by_email", "Email");

                    // 1. Do you receive your own copy of Abilities magazine? (Y/N)?
                    var checkOwnCopyIndex = survey.createIndex("by_checkowncopy", "CheckOwnCopy");

                    // 2. Including yourself, how many other people read your copy of Abilities? (On average, ___ people read my copy)
                    var numberOfReaders = survey.createIndex("by_numberofreaders", "NumberOfReaders");

                    // 3. Do you find Abilities to be education and informative? (Very much, Some, Not at all, Comments) 
                    var educational = survey.createIndex("by_educational", "Educational");
                    var educationalComment = survey.createIndex("by_educationalcomment", "EducationalComment");

                    // 4. How much time do you spend reading Abilities? (Up to 30 minutes, 30 minutes to one hour, More than one hour) 
                    var timeSpent = survey.createIndex("by_timespent", "TimeSpent");

                    // 5. How much does the content in Abilities help you in your daily life? (Very much, Some, Not at all, comments)
                    var helpfulness = survey.createIndex("by_helpfulness", "Helpfulness");
                    var helpfulnessComment = survey.createIndex("by_helpfulnesscomment", "HelpfulnessComment");

                    // 6. What kind of information or articles would you like to see more of? (Comments) 
                    var preferredInfo = survey.createIndex("by_preferredInfo", "PreferredInfo");

                    // 7. Which products do you identify a need for or recommend? Check all that apply. 
                    var recommendedProduct = survey.createIndex("by_recommnededproduct", "RecommendedProduct");

                    // 8. How often do you visit our website (abilities.ca)? 
                    var websiteVisits = survey.createIndex("by_websitevisits", "WebsiteVisits");

                    // 9. How often do you connect with our social media sites (Facebook, Twitter, etc.)? 
                    var socialVisits = survey.createIndex("by_socialvisits", "SocialVisits");

                    // 10. Abilities magazine should provide (check all that apply): 
                    var magazineOffer = survey.createIndex("by_magazineoffer", "MagazineOffer");

                    // Would you be interested in contributing an article or a case study? (Yes, no) 
                    var checkContribution = survey.createIndex("by_checkcontribution", "CheckContribution");

                    //} else if (evt.oldVersion < 2) {

                    //}
                };
            } //catch (ex) {        
        }
    };

    return that;
}();